"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const zhin_1 = require("zhin");
const http_1 = require("http");
const koa_1 = __importDefault(require("koa"));
const koa_basic_auth_1 = __importDefault(require("koa-basic-auth"));
const koa_bodyparser_1 = __importDefault(require("koa-bodyparser"));
const router_1 = require("./router");
const process = __importStar(require("process"));
__exportStar(require("./router"), exports);
const koa = new koa_1.default();
const username = process.env.username || 'admin';
const password = process.env.password || '123456';
koa.use((0, koa_basic_auth_1.default)({
    name: username,
    pass: password,
}));
const server = (0, http_1.createServer)(koa.callback());
const router = new router_1.Router(server, { prefix: process.env.routerPrefix || '' });
const outputCommand = (command) => {
    return {
        name: command.name,
        desc: command.config.desc,
        alias: command.aliasNames,
        hidden: command.config.hidden,
        help: command.help(),
    };
};
router.get('/api/plugins', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = httpServer.app.pluginList.map(plugin => {
        return {
            full_name: plugin.name,
            display_name: plugin.display_name,
            status: plugin.status,
            middlewareCount: plugin.middlewares.length,
            commands: [...plugin.commands.values()].map(outputCommand),
            services: [...plugin.services.entries()].map(([name]) => name),
        };
    });
});
router.get('/api/plugin/:name/commands', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = [...(httpServer.app?.plugins.get(ctx.params.name)?.commands.values() || [])].map(outputCommand);
});
router.get('/api/config', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = httpServer.app.config;
});
router.get('/api/adapters', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = [...httpServer.app.adapters.values()].map(adapter => {
        return {
            name: adapter.name,
            bots: adapter.bots.map(bot => {
                return bot.unique_id;
            }),
        };
    });
});
router.get('/api/adapter/:name/bots', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body =
        httpServer.app?.adapters.get(ctx.params.name)?.bots.map(bot => {
            return bot.unique_id;
        }) || [];
});
router.get('/api/bots', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = [...(httpServer.app?.adapters.values() || [])].reduce((result, adp) => {
        return result.concat(adp.bots.map(bot => {
            return bot.unique_id;
        }));
    }, []);
});
router.get('/api/commands', (ctx) => {
    ctx.response.headers['Content-Type'] = 'application/json';
    ctx.body = [...httpServer.app.commandList].map(outputCommand);
});
const httpServer = new zhin_1.Plugin('http-server');
httpServer.service('server', server).service('koa', koa).service('router', router);
koa.use((0, koa_bodyparser_1.default)()).use(router.routes()).use(router.allowedMethods());
server.listen({
    host: '0.0.0.0',
    port: Number(((_a = process.env).port || (_a.port = '8086'))),
}, () => {
    const address = server.address();
    if (!address)
        return;
    const visitAddress = typeof address === 'string' ? address : `${address.address}:${address.port}`;
    httpServer.app?.logger.mark(`server is running at http://${visitAddress}`);
    httpServer.app?.logger.info('your username is：', username);
    httpServer.app?.logger.info('your password is：', password);
});
httpServer.on('plugin-beforeUnmount', () => {
    server.close();
});
exports.default = httpServer;
